<?php
// ----------------------------------------------------------------------
// Copyright (c) 2002-2006 Shawn McKenzie
// http://spidean.mckenzies.net
// ----------------------------------------------------------------------
// LICENSE
//
// This software is the copyrighted material of Shawn McKenzie. AutoTheme is
// licensed for use on (1) web site installation only. See the license.txt for your
// specific license.
// 
// YOU AGREE NOT TO COPY OR DISTRIBUTE THIS SOFTWARE OR CHANGE THE SOURCE CODE
// WITHOUT PRIOR WRITTEN PERMISSION. PLEASE SEND ANY QUESTIONS OR COMMENTS TO
// AUTOTHEME@MCKENZIES.NET.
// 
// SHAWN MCKENZIE, TAKES NO RESPONSIBILITY FOR ANY DAMAGE THAT THIS SOFTWARE MIGHT
// CAUSE.
//
// Additional licensing information is available from autotheme@mckenzies.net.
// 
// If you disagree with any of these terms, you are not authorized to use this
// software. If you do agree with these terms, please enjoy.
// ----------------------------------------------------------------------

function atExtendedInit()
{
	if ($content = atCacheRead()) {
		echo $content;
		
		if ($renderstart = atRunningGetVar('renderstart')) {
			$mtime = explode(" ", microtime());
			$renderstop = $mtime[1] + $mtime[0];
			$rendertime = ($renderstop - $renderstart);

			printf('<div align="center">'._AT_READFROMCACHE." %f "._AT_SECONDS.'</div>', $rendertime);
		}
		return die();
	}
	return array();
}

function atThemeExit()
{
	$runningconfig = atGetRunningConfig();
    extract($runningconfig);

    $display = ob_get_contents();
    list($junk, $display) = atTemplateSplit($display, "#AUTOTHEME_START#");
    
    $display = atThemeAddHeader().$display;
    $display = str_replace('$', '\$', $display);
        
	//atRunningSetVar('display', $display);
	//atCommandAdd('display', 'echo $display;');
	
	$template = $template['dtd'];
	
	if (!$template) {
        $template = "HTML401_Transitional.html";
    }
    if (@file_exists($themepath.$template)) {
		$file = $themepath.$template;
	}
	elseif (@file_exists($atdir."templates/$platform/$template")) {
		$file = $atdir."templates/$platform/$template";
	}
	else {
		$file = $atdir."templates/HTML.html";
	}
	$HTML = atTemplateRead($file);
	$HTML = eregi_replace('\<\/head\>', '', $HTML);
	$HTML = preg_replace('/(\<\!--[ ]*\[|{)display(}|\][ ]*--\>)/', $display, $HTML);
	$output = atCommandReplace($HTML);

	ob_end_clean();
	ob_start();	
    atTemplateDisplay($output);
    
    atCacheWrite();
    
    return die();
}
	
function atThemeAddHeader()
{
    $runningconfig = atGetRunningConfig();
    extract($runningconfig);
 
    $stylesheet = $style['stylesheet'];
    
    $head = "\n<!--\n************************ AutoTheme 1.77 *************************\n-->\n";
    
    if (atGetModName() == "AutoTheme") {
    	$head .= "<script type=\"text/javascript\" src=\"modules/AutoTheme/javascript/picker.js\"></script>\n"
				."<script type=\"text/javascript\">\n"
				."  var JS_PATH = \"modules/AutoTheme/javascript/\";\n"
				."  var PU_PATH = JS_PATH + \"popups/\";\n"
				."</script>\n";
    }
    if (isset($stylesheet)) {
        if (@file_exists($themepath.$stylesheet) && !@is_dir($themepath.$stylesheet)) {
            $head .= "\n<!-- Custom Page stylesheet -->\n";
        	$head .= "<link rel=\"stylesheet\" href=\"".$themepath.$stylesheet."\" type=\"text/css\""
        	.($xhtml ? " />" : ">")."\n";
        }
    }
    if ($system = atPlatformHeader($xhtml)) {
	    $head .= "\n<!-- Head from system -->\n";
	    $head .= "$system\n";
    }
    if ($style['head']) {
	    $head .= "\n<!-- Head from config -->\n";
	    $head .= trim($style['head'])."\n";
    }    
    return $head;
}

function atThemeAddFooter()
{
    $footer = "\n<!--\n************************ AutoTheme 1.77 ************************\n-->\n";

	echo $footer;
}

function atCacheRead()
{
	$runningconfig = atGetRunningConfig();
    extract($runningconfig);
        
	$cache_on = $cache['on'];
	$cache_expire = $cache['expire'];
	$db_expire = $cache['db'];
	$exclude = $cache['exclude'];
	$oldmask = umask(0); 
	
	if (!$cache_on) {
		return false;
	}
	elseif (in_array($modname, $exclude) || in_array($modtemplate, $exclude)) {
		return false;
	} 
    $filename = atGetCacheFilename();
    
    if (@filemtime($cachedir.$filename) >= (time() - $cache_expire)) {
    	if ($output = atTemplateRead($cachedir.$filename)) {
    		return $output;
    	}
    	else {
    		return false;
    	}
    }
    else {
    	return false;
    }
}

function atCacheWrite()
{
    $runningconfig = atGetRunningConfig();
    extract($runningconfig);
        
	$cache_on = $cache['on'];
    $cache_expire = $cache['expire'];
    $db_expire = $cache['db'];
	$exclude = $cache['exclude'];
	$oldmask = umask(0);
	
	if (!$cache_on) {
		return false;
	}
	elseif (in_array($modname, $exclude) || in_array($modtemplate, $exclude)) {
		return false;
	}
    $filename = atGetCacheFilename();

  	$content = ob_get_contents();
    
    if ($handle = @fopen($cachedir.$filename, "w")) {
        fwrite($handle, $content);
	    fclose($handle);
    }
}

function atCacheClear()
{
    $cachedir = atAutoGetVar('cachedir');

    if ($handle = @opendir($cachedir)) {
            while (false !== ($file = @readdir($handle))) {
                @unlink($cachedir.$file);
            }
            closedir($handle);
    }
}

function atGetCacheFilename()
{	
	$username = atGetUserName();
	$thename = atRunningGetVar('thename');
		
	$getvars = 'GET'.serialize($_GET);
	$postvars = 'POST'.serialize($_POST);
	$temp = $username.$thename.$_SERVER['REQUEST_URI'].$getvars.$postvars;
	$filename = md5($temp);

	return $filename;
}

?>
